| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Private Attributes | List of all members
SequencerTimerTool Class Reference

Implements the time measurement inside a sequencer. More...

`#include <src/components/SequencerTimerTool.h>`

Inheritance diagram for SequencerTimerTool:
[legend]
Collaboration diagram for SequencerTimerTool:
[legend]

## Public Member Functions
| SequencerTimerTool (const std::string &type, const std::string &name, const IInterface *parent)
| Standard constructor. More...
StatusCode | initialize () override
| initialize method, to compute the normalization factor More...
StatusCode | finalize () override
| finalize method, to print the time summary table More...
int | addTimer (const std::string &name) override
| add a timer entry with the specified name More...
void | increaseIndent () override
| Increase the indentation of the name. More...
void | decreaseIndent () override
| Decrease the indentation of the name. More...
void | start (int index) override
| start the counter, i.e. More...
double | stop (int index) override
| stop the counter, return the elapsed time More...
double | lastTime (int index) override
| returns the last time More...
const std::string & | name (int index) override
| returns the name of the counter More...
int | indexByName (const std::string &name) override
| returns the index of the counter with that name, or -1 More...
bool | globalTiming () override
| returns the flag telling that global timing is wanted More...
void | saveHistograms () override
| prepares and saves the timing histograms More...
virtual const std::string & | name (int index)=0
| returns the name of the counter More...
virtual void | start (int index)=0
| start the counter, i.e. More...
virtual StatusCode | start ()=0
| Start (from INITIALIZED to RUNNING). More...
virtual double | stop (int index)=0
| stop the counter, return the elapsed time More...
virtual StatusCode | stop ()=0
| Stop (from RUNNING to INITIALIZED). More...
Public Member Functions inherited from GaudiHistoTool
| GaudiHistoTool ()=delete
| GaudiHistoTool (const GaudiHistoTool &)=delete
GaudiHistoTool & | operator= (const GaudiHistoTool &)=delete
Public Member Functions inherited from GaudiHistos< GaudiTool >
AIDA::IHistogram1D * | plot1D (const double value, const std::string &title, const double low, const double high, const unsigned long bins=100, const double weight=1.0) const
| fill the 1D histogram (book on demand) More...
AIDA::IHistogram1D * | plot1D (const double value, const Gaudi::Histo1DDef &hdef, const double weight=1.0) const
| fill the 1D histogram (book on demand) More...
AIDA::IHistogram1D * | plot1D (const double value, const HistoID &ID, const std::string &title, const double low, const double high, const unsigned long bins=100, const double weight=1.0) const
| fill the 1D histogram with forced ID assignment (book on demand) More...
AIDA::IHistogram1D * | plot1D (const double value, const HistoID &ID, const Gaudi::Histo1DDef &hdef, const double weight=1.0) const
| fill the 1D histogram with forced ID assignment (book on demand) More...
AIDA::IHistogram1D * | plot1D (const double value, const std::string &title, const HistoBinEdges &edges, const double weight=1.0) const
| Fill the 1D variable binning histogram (book on demand) More...
AIDA::IHistogram1D * | plot1D (const double value, const HistoID &ID, const std::string &title, const HistoBinEdges &edges, const double weight=1.0) const
| fill the 1D variable binning histogram with forced ID assignment (book on demand) More...
AIDA::IHistogram1D * | plot (const double value, const std::string &title, const double low, const double high, const unsigned long bins=100, const double weight=1.0) const
| fill the 1D histogram (book on demand) More...
AIDA::IHistogram1D * | plot (const double value, const Gaudi::Histo1DDef &hdef, const double weight=1.0) const
| fill the 1D histogram (book on demand) More...
AIDA::IHistogram1D * | plot (const double value, const HistoID &ID, const std::string &title, const double low, const double high, const unsigned long bins=100, const double weight=1.0) const
| fill the 1D histogram with forced ID assignment (book on demand) More...
AIDA::IHistogram1D * | plot (const double value, const HistoID &ID, const Gaudi::Histo1DDef &hdef, const double weight=1.0) const
| fill the 1D histogram (book on demand) More...
AIDA::IHistogram1D * | plot (const FUNCTION &func, OBJECT first, OBJECT last, const std::string &title, const double low, const double high, const unsigned long bins=100) const
| fill the 1D histogram with information from [first,last) sequence More...
AIDA::IHistogram1D * | plot (const FUNCTION &func, OBJECT first, OBJECT last, const HistoID &ID, const std::string &title, const double low, const double high, const unsigned long bins=100) const
| fill the 1D histogram with forced ID and information from [first,last) sequence More...
AIDA::IHistogram1D * | plot (const FUNCTION &func, OBJECT first, OBJECT last, const std::string &title, const double low, const double high, const unsigned long bins, const WEIGHT &weight) const
| book and fill the 1D histogram with information from [first,last) sequence with given weight More...
AIDA::IHistogram1D * | plot (const FUNCTION &func, OBJECT first, OBJECT last, const HistoID &ID, const std::string &title, const double low, const double high, const unsigned long bins, const WEIGHT &weight) const
| book and fill the 1D histogram with forced ID and information from [first,last) sequence with given weight More...
AIDA::IHistogram2D * | plot2D (const double valueX, const double valueY, const std::string &title, const double lowX, const double highX, const double lowY, const double highY, const unsigned long binsX=50, const unsigned long binsY=50, const double weight=1.0) const
| fill the 2D histogram (book on demand) More...
AIDA::IHistogram2D * | plot2D (const double valueX, const double valueY, const HistoID &ID, const std::string &title, const double lowX, const double highX, const double lowY, const double highY, const unsigned long binsX=50, const unsigned long binsY=50, const double weight=1.0) const
| fill the 2D histogram with forced ID assignment (book on demand) More...
AIDA::IHistogram2D * | plot2D (const double valueX, const double valueY, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY, const double weight=1.0) const
| Fill the 2D variable binning histogram (book on demand) More...
AIDA::IHistogram2D * | plot2D (const double valueX, const double valueY, const HistoID &ID, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY, const double weight=1.0) const
| fill the 2D variable histogram with forced ID assignment (book on demand) More...
AIDA::IHistogram3D * | plot3D (const double valueX, const double valueY, const double valueZ, const std::string &title, const double lowX, const double highX, const double lowY, const double highY, const double lowZ, const double highZ, const unsigned long binsX=10, const unsigned long binsY=10, const unsigned long binsZ=10, const double weight=1.0) const
| fill the 3D histogram (book on demand) More...
AIDA::IHistogram3D * | plot3D (const double valueX, const double valueY, const double valueZ, const HistoID &ID, const std::string &title, const double lowX, const double highX, const double lowY, const double highY, const double lowZ, const double highZ, const unsigned long binsX=10, const unsigned long binsY=10, const unsigned long binsZ=10, const double weight=1.0) const
| fill the 3D histogram with forced ID assignment (book on demand) More...
AIDA::IHistogram3D * | plot3D (const double valueX, const double valueY, const double valueZ, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY, const HistoBinEdges &edgesZ, const double weight=1.0) const
| Fill the 3D variable binning histogram (book on demand) More...
AIDA::IHistogram3D * | plot3D (const double valueX, const double valueY, const double valueZ, const HistoID &ID, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY, const HistoBinEdges &edgesZ, const double weight=1.0) const
| fill the 3D histogram with forced ID assignment (book on demand) More...
AIDA::IProfile1D * | profile1D (const double valueX, const double valueY, const std::string &title, const double lowX, const double highX, const unsigned long binsX=100, const std::string &opt="", const double lowY=-std::numeric_limits< double >::max(), const double highY=std::numeric_limits< double >::max(), const double weight=1.0) const
| fill the 1D profile histogram (book on demand) More...
AIDA::IProfile1D * | profile1D (const double valueX, const double valueY, const HistoID &ID, const std::string &title, const double lowX, const double highX, const unsigned long binsX=100, const std::string &opt="", const double lowY=-std::numeric_limits< double >::max(), const double highY=std::numeric_limits< double >::max(), const double weight=1.0) const
| fill the 1D profile histogram with forced ID assignment (book on demand) More...
AIDA::IProfile1D * | profile1D (const double valueX, const double valueY, const std::string &title, const HistoBinEdges &edges, const double weight=1.0) const
| fill the 1D variable binning profile histogram (book on demand) More...
AIDA::IProfile1D * | profile1D (const double valueX, const double valueY, const HistoID &ID, const std::string &title, const HistoBinEdges &edges, const double weight=1.0) const
| fill the 1D variable binning profile histogram with forced ID assignment (book on demand) More...
AIDA::IProfile1D * | profile1D (const std::string &title) const
| access the EXISTING 1D profile histogram by title return the pointer to existing 1D profile histogram or NULL More...
AIDA::IProfile1D * | profile1D (const HistoID &ID) const
| access the EXISTING 1D profile histogram by ID return the pointer to existing 1D profile histogram or NULL More...
AIDA::IProfile2D * | profile2D (const double valueX, const double valueY, const double valueZ, const std::string &title, const double lowX, const double highX, const double lowY, const double highY, const unsigned long binsX=50, const unsigned long binsY=50, const double weight=1.0) const
| fill the 2D profile histogram (book on demand) More...
AIDA::IProfile2D * | profile2D (const double valueX, const double valueY, const double valueZ, const HistoID &ID, const std::string &title, const double lowX, const double highX, const double lowY, const double highY, const unsigned long binsX=50, const unsigned long binsY=50, const double weight=1.0) const
| fill the 2D profile histogram with forced ID assignment (book on demand) More...
AIDA::IProfile2D * | profile2D (const double valueX, const double valueY, const double valueZ, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY, const double weight=1.0) const
| fill the 2D variable binning profile histogram (book on demand) More...
AIDA::IProfile2D * | profile2D (const double valueX, const double valueY, const double valueZ, const HistoID &ID, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY, const double weight=1.0) const
| fill the 2D variable binning profile histogram with forced ID assignment (book on demand) More...
AIDA::IProfile2D * | profile2D (const std::string &title) const
| access the EXISTING 2D profile histogram by title return the pointer to existing 2D profile histogram or NULL More...
AIDA::IProfile2D * | profile2D (const HistoID &ID) const
| access the EXISTING 2D profile histogram by ID return the pointer to existing 2D profile histogram or NULL More...
AIDA::IHistogram1D * | book1D (const std::string &title, const double low=0, const double high=100, const unsigned long bins=100) const
| book the 1D histogram More...
AIDA::IHistogram1D * | book1D (const HistoID &ID, const std::string &title, const double low=0, const double high=100, const unsigned long bins=100) const
| book the 1D histogram with forced ID More...
AIDA::IHistogram1D * | book1D (const std::string &title, const HistoBinEdges &edges) const
| book the 1D variable binning histogram More...
AIDA::IHistogram1D * | book1D (const HistoID &ID, const std::string &title, const HistoBinEdges &edges) const
| book the 1D variable binning histogram with given ID More...
AIDA::IHistogram1D * | book (const std::string &title, const double low=0, const double high=100, const unsigned long bins=100) const
| book the 1D histogram More...
AIDA::IHistogram1D * | book (const Gaudi::Histo1DDef &hdef) const
| book the 1D histogram More...
AIDA::IHistogram1D * | book (const HistoID &ID, const std::string &title, const double low=0, const double high=100, const unsigned long bins=100) const
| book the 1D histogram with forced ID More...
AIDA::IHistogram1D * | book (const HistoID &ID, const Gaudi::Histo1DDef &hdef) const
| book the 1D histogram with forced ID More...
AIDA::IHistogram2D * | book2D (const std::string &title, const double lowX=0, const double highX=100, const unsigned long binsX=50, const double lowY=0, const double highY=100, const unsigned long binsY=50) const
| book the 2D histogram More...
AIDA::IHistogram2D * | book2D (const HistoID &ID, const std::string &title, const double lowX=0, const double highX=100, const unsigned long binsX=50, const double lowY=0, const double highY=100, const unsigned long binsY=50) const
| book the 2D histogram with forced ID More...
AIDA::IHistogram2D * | book2D (const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY) const
| book the 2D variable binning histogram More...
AIDA::IHistogram2D * | book2D (const HistoID &ID, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY) const
| book the 2D variable binning histogram with given ID More...
AIDA::IHistogram3D * | book3D (const std::string &title, const double lowX=0, const double highX=100, const unsigned long binsX=10, const double lowY=0, const double highY=100, const unsigned long binsY=10, const double lowZ=0, const double highZ=100, const unsigned long binsZ=10) const
| book the 3D histogram More...
AIDA::IHistogram3D * | book3D (const HistoID &ID, const std::string &title, const double lowX=0, const double highX=100, const unsigned long binsX=10, const double lowY=0, const double highY=100, const unsigned long binsY=10, const double lowZ=0, const double highZ=100, const unsigned long binsZ=10) const
| book the 3D histogram with forced ID More...
AIDA::IHistogram3D * | book3D (const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY, const HistoBinEdges &edgesZ) const
| book the 3D variable binning histogram More...
AIDA::IHistogram3D * | book3D (const HistoID &ID, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY, const HistoBinEdges &edgesZ) const
| book the 3D variable binning histogram with given ID More...
AIDA::IProfile1D * | bookProfile1D (const std::string &title, const double low=0, const double high=100, const unsigned long bins=100, const std::string &opt="", const double lowY=-std::numeric_limits< double >::max(), const double highY=std::numeric_limits< double >::max()) const
| book the 1D profile histogram More...
AIDA::IProfile1D * | bookProfile1D (const HistoID &ID, const std::string &title, const double low=0, const double high=100, const unsigned long bins=100, const std::string &opt="", const double lowY=-std::numeric_limits< double >::max(), const double highY=std::numeric_limits< double >::max()) const
| book the 1D profile histogram More...
AIDA::IProfile1D * | bookProfile1D (const std::string &title, const HistoBinEdges &edges) const
| book the 1D profile histogram More...
AIDA::IProfile1D * | bookProfile1D (const HistoID &ID, const std::string &title, const HistoBinEdges &edges) const
| book the 1D profile histogram More...
AIDA::IProfile2D * | bookProfile2D (const std::string &title, const double lowX=0, const double highX=100, const unsigned long binsX=50, const double lowY=0, const double highY=100, const unsigned long binsY=50) const
| book the 2D profile histogram More...
AIDA::IProfile2D * | bookProfile2D (const HistoID &ID, const std::string &title, const double lowX=0, const double highX=100, const unsigned long binsX=50, const double lowY=0, const double highY=100, const unsigned long binsY=50) const
| book the 2D profile histogram with forced ID More...
AIDA::IProfile2D * | bookProfile2D (const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY) const
| book the 2D profile histogram More...
AIDA::IProfile2D * | bookProfile2D (const HistoID &ID, const std::string &title, const HistoBinEdges &edgesX, const HistoBinEdges &edgesY) const
| book the 2D profile histogram with forced ID More...
AIDA::IHistogram1D * | fill (AIDA::IHistogram1D *histo, const double value, const double weight, const std::string &title="") const
| fill the 1D histogram with the value and weight More...
AIDA::IHistogram2D * | fill (AIDA::IHistogram2D *histo, const double valueX, const double valueY, const double weight, const std::string &title="") const
| fill the 2D histogram with the value and weight More...
AIDA::IHistogram3D * | fill (AIDA::IHistogram3D *histo, const double valueX, const double valueY, const double valueZ, const double weight, const std::string &title="") const
| fill the 3D histogram with the value and weight More...
AIDA::IProfile1D * | fill (AIDA::IProfile1D *histo, const double valueX, const double valueY, const double weight, const std::string &title="") const
| fill the 1D profile histogram with the values and weight More...
AIDA::IProfile2D * | fill (AIDA::IProfile2D *histo, const double valueX, const double valueY, const double valueZ, const double weight, const std::string &title="") const
| fill the 2D profile histogram with the values and weight More...
AIDA::IHistogram1D * | histo1D (const std::string &title) const
| access the EXISTING 1D histogram by title return the pointer to existing 1D histogram or NULL More...
AIDA::IHistogram1D * | histo1D (const HistoID &ID) const
| access the EXISTING 1D histogram by ID return the pointer to existing 1D histogram or NULL More...
AIDA::IHistogram1D * | histo (const std::string &title) const
| access the EXISTING 1D histogram by title More...
AIDA::IHistogram1D * | histo (const HistoID &ID) const
| access the EXISTING 1D histogram by ID More...
AIDA::IHistogram2D * | histo2D (const std::string &title) const
| access the EXISTING 2D histogram by title return the pointer to existing 2D histogram or NULL More...
AIDA::IHistogram2D * | histo2D (const HistoID &ID) const
| access the EXISTING 2D histogram by ID return the pointer to existing 2D histogram or NULL More...
AIDA::IHistogram3D * | histo3D (const std::string &title) const
| access the EXISTING 3D histogram by title return the pointer to existing 3D histogram or NULL More...
AIDA::IHistogram3D * | histo3D (const HistoID &ID) const
| access the EXISTING 3D histogram by ID return the pointer to existing 3D histogram or NULL More...
bool | histoExists (const std::string &title) const
| check the existence AND validity of the histogram with given title More...
bool | histoExists (const HistoID &ID) const
| check the existence AND validity of the histogram with given title More...
unsigned int | totalNumberOfHistos () const
| Returns the total number of histograms (of all types) currently booked. More...
bool | produceHistos () const
| get the flag for histogram production (property "HistoProduce") More...
bool | fullDetail () const
| get flag to control output level of histograms More...
bool | checkForNaN () const
| get the flag for NaN checks (property "HistoCheckForNan") More...
bool | splitHistoDir () const
| get the flag for histogram path split (property "HistoSplitDir") More...
HistoID::NumericID | histoOffSet () const
| get the value for histogram offset (property "HistoOffSet") More...
const std::string & | histoTopDir () const
| get top-level histogram directory (property "HistoTopDir") More...
const std::string & | histoDir () const
| get histogram directory (property "HistoDir") More...
std::string | histoPath () const
| get the constructed histogram path More...
bool | histosPrint () const
| print histograms at finalization ? More...
bool | histoCountersPrint () const
| print histogram counters at finalization ? More...
bool | useNumericAutoIDs () const
| Use old style sequencial numerical automatically assigned IDs ? More...
int | printHistos (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of histograms More...
const Histo1DMapTitle & | histo1DMapTitle () const
| get access to the map of all 1D histograms indexed via their title More...
const Histo1DMapID & | histo1DMapID () const
| get access to the map of all 1D histograms index via ID More...
const Histo2DMapTitle & | histo2DMapTitle () const
| get access to the map of all 2D histograms indexed via their title More...
const Histo2DMapID & | histo2DMapID () const
| get access to the map of 2D histograms index via ID More...
const Histo3DMapTitle & | histo3DMapTitle () const
| get access to the map of all 3D histograms indexed via their title More...
const Histo3DMapID & | histo3DMapID () const
| get access to the map of all 3D histograms index via a ID More...
const Profile1DMapTitle & | profile1DMapTitle () const
| get access to the map of all 1D profile histograms indexed via their title More...
const Profile1DMapID & | profile1DMapID () const
| get access to the map of 1D profile histograms index via a ID More...
const Profile2DMapTitle & | profile2DMapTitle () const
| get access to the map of all 2D profile histograms indexed via their title More...
const Profile2DMapID & | profile2DMapID () const
| get access to the map of 2D profile histograms index via a ID More...
void | setProduceHistos (const bool val)
| set the flag for histogram production (property "HistoProduce") More...
void | setFullDetail (const bool val)
| set flag to control output level of histograms More...
void | setCheckForNaN (const bool val)
| set the flag for NaN checks (property "HistoCheckForNan") More...
void | setSplitHistoDir (const bool val)
| set the flag for histogram path split (property "HistoSplitDir") More...
void | setHistoOffSet (const HistoID::NumericID val)
| set a value for histogram offset (property "HistoOffSet" More...
void | setHistoTopDir (const std::string &val)
| set top-level histogram directory (property "HistoTopDir") More...
void | setHistoDir (const std::string &val)
| set histogram directory (property "HistoDir") More...
| GaudiHistos (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if PBASE derives from GaudiAlgorithm. More...
| GaudiHistos (const std::string &type, const std::string &name, const IInterface *parent)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if PBASE derives from GaudiTool. More...
Public Member Functions inherited from GaudiTool
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
INTupleSvc * | ntupleSvc () const
| Access the standard N-Tuple. More...
INTupleSvc * | evtColSvc () const
| Access the standard event collection service. More...
IDataProviderSvc * | detSvc () const
| accessor to detector service More...
IIncidentSvc * | incSvc () const
| accessor to Incident Service More...
IChronoStatSvc * | chronoSvc () const
| accessor to Chrono & Stat Service More...
IHistogramSvc * | histoSvc () const
| acessor to the histogram service More...
IAlgContextSvc * | contextSvc () const
| acessor to the Algorithm Context Service More...
void | put (IDataProviderSvc *svc, DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
void | put (IDataProviderSvc *svc, std::unique_ptr< DataObject > object, const std::string &address, const bool useRootInTES=true) const
const DataObject * | put (DataObject *object, const std::string &address, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
const DataObject * | put (std::unique_ptr< DataObject > object, const std::string &address, const bool useRootInTES=true) const
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | get (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data from Gaudi Event Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
template<class TYPE >
TYPE * | getDet (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (IDataProviderSvc *svc, const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
TYPE * | getDet (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
Gaudi::Utils::GetData< TYPE >::return_type | getDetIfExists (const std::string &location) const
| Templated access to the detector data from the Gaudi Detector Transient Store. More...
template<class TYPE >
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | exist (const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
template<class TYPE >
bool | existDet (IDataProviderSvc *svc, const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE >
bool | existDet (const std::string &location) const
| Check the existence of detector objects in the Gaudi Transient Detector Store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
template<class TYPE , class TYPE2 >
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
| GaudiTool (const std::string &type, const std::string &name, const IInterface *parent)
| Standard constructor. More...
| ~GaudiTool () override
| destructor, virtual and protected More...
Public Member Functions inherited from GaudiCommon< CounterHolder< AlgTool > >
Gaudi::Utils::GetData< TYPE >::return_type | get (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Templated access to the data in Gaudi Transient Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getIfExists (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Quicker version of the get function which bypasses the check on the retrieved data. More...
bool | exist (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Check the existence of a data object or container in the Gaudi Transient Event Store. More...
Gaudi::Utils::GetData< TYPE >::return_type | getOrCreate (IDataProviderSvc *svc, const std::string &location, const bool useRootInTES=true) const
| Get the existing data object from Gaudi Event Transient store. More...
DataObject * | put (IDataProviderSvc *svc, std::unique_ptr< DataObject > object, const std::string &location, const bool useRootInTES=true) const
| Register a data object or container into Gaudi Event Transient Store. More...
DataObject * | put (IDataProviderSvc *svc, DataObject *object, const std::string &location, const bool useRootInTES=true) const
TOOL * | tool (const std::string &type, const std::string &name, const IInterface *parent=0, bool create=true) const
| Useful method for the easy location of tools. More...
TOOL * | tool (const std::string &type, const IInterface *parent=0, bool create=true) const
| A useful method for the easy location of tools. More...
SmartIF< SERVICE > | svc (const std::string &name, const bool create=true) const
| A useful method for the easy location of services. More...
IUpdateManagerSvc * | updMgrSvc () const
| Short-cut to locate the Update Manager Service. More...
WARN_UNUSED StatusCode | Error (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the error message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Warning (const std::string &msg, const StatusCode st=StatusCode::FAILURE, const size_t mx=10) const
| Print the warning message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Info (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const size_t mx=10) const
| Print the info message and return with the given StatusCode. More...
WARN_UNUSED StatusCode | Print (const std::string &msg, const StatusCode st=StatusCode::SUCCESS, const MSG::Level lev=MSG::INFO) const
| Print the message and return with the given StatusCode. More...
void | Assert (const bool ok, const std::string &message="", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Assert (const bool ok, const char *message, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Assertion - throw exception if the given condition is not fulfilled. More...
void | Exception (const std::string &msg, const GaudiException &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given GaudiException. More...
void | Exception (const std::string &msg, const std::exception &exc, const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and (re)-throw a given exception. More...
void | Exception (const std::string &msg="no message", const StatusCode sc=StatusCode(StatusCode::FAILURE, true)) const
| Create and throw an exception with the given message. More...
StatEntity & | counter (const std::string &tag) const
| accessor to certain counter by name More...
StatEntity & | counter (const std::string &tag)
bool | typePrint () const
| Insert the actual C++ type of the algorithm/tool in the messages ? More...
bool | propsPrint () const
| Print properties at initialization ? More...
bool | statPrint () const
| Print statistical counters at finalization ? More...
bool | errorsPrint () const
| Print error counters at finalization ? More...
long | printStat (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of statistical counters More...
long | printErrors (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of error counters More...
long | printProps (const MSG::Level level=MSG::ALWAYS) const
| perform the actual printout of properties More...
void | registerCondition (const std::string &condition, StatusCode(CallerClass::*mf)()=nullptr)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (const std::string &condition, CondType *&condPtrDest, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
void | registerCondition (char *condition, StatusCode(CallerClass::*mf)()=NULL)
| just to avoid conflicts with the version using a pointer to a template class. More...
void | registerCondition (TargetClass *condition, StatusCode(CallerClass::*mf)()=NULL)
| register the current instance to the UpdateManagerSvc as a consumer for a condition. More...
StatusCode | runUpdate ()
| asks the UpdateManagerSvc to perform an update of the instance (if needed) without waiting the next BeginEvent incident. More...
| GaudiCommon (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if PBASE derives from Algorithm. More...
| GaudiCommon (const std::string &type, const std::string &name, const IInterface *ancestor)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if PBASE derives from AlgTool. More...
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
StatusCode | release (const IInterface *interface) const
| Manual forced (and 'safe') release of the active tool or service. More...
const Services & | services () const
| get the list of aquired services More...
const std::string & | context () const
| Returns the "context" string. Used to identify different processing states. More...
Public Member Functions inherited from FixTESPath< BASE >
template<typename U = BASE, typename = std::enable_if_t<std::is_base_of_v<Gaudi::Algorithm, BASE>, U>>
| FixTESPath (const std::string &name, ISvcLocator *pSvcLocator)
| Algorithm constructor - the SFINAE constraint below ensures that this is constructor is only defined if BASE derives from Algorithm. More...
template<typename U = BASE, typename = std::enable_if_t<std::is_base_of_v<AlgTool, BASE>, U>>
| FixTESPath (const std::string &type, const std::string &name, const IInterface *ancestor)
| Tool constructor - SFINAE-ed to insure this constructor is only defined if BASE derives from AlgTool. More...
StatusCode | initialize () override
const std::string & | rootInTES () const
| Returns the "rootInTES" string. More...
std::string | fullTESLocation (std::string_view location, bool useRootInTES) const
| Returns the full correct event location given the rootInTes settings. More...
Public Member Functions inherited from ISequencerTimerTool
| DeclareInterfaceID (ISequencerTimerTool, 3, 0)
| InterfaceID. More...
virtual StatusCode | start ()=0
| Start (from INITIALIZED to RUNNING). More...
virtual StatusCode | stop ()=0
| Stop (from RUNNING to INITIALIZED). More...
Public Member Functions inherited from IAlgTool
| DeclareInterfaceID (IAlgTool, 4, 0)
| InterfaceID. More...
virtual const std::string & | type () const =0
| The type of an AlgTool, meaning the concrete AlgTool class. More...
virtual const IInterface * | parent () const =0
| The parent of the concrete AlgTool. More...
virtual StatusCode | configure ()=0
| Configuration (from OFFLINE to CONFIGURED). More...
virtual StatusCode | start ()=0
| Start (from INITIALIZED to RUNNING). More...
virtual StatusCode | stop ()=0
| Stop (from RUNNING to INITIALIZED). More...
virtual StatusCode | terminate ()=0
| Initialization (from CONFIGURED to OFFLINE). More...
virtual StatusCode | reinitialize ()=0
| Initialization (from INITIALIZED or RUNNING to INITIALIZED, via CONFIGURED). More...
virtual StatusCode | restart ()=0
| Initialization (from RUNNING to RUNNING, via INITIALIZED). More...
virtual Gaudi::StateMachine::State | FSMState () const =0
| Get the current state. More...
virtual StatusCode | sysInitialize ()=0
| Initialization of the Tool. More...
virtual StatusCode | sysStart ()=0
| Initialization of the Tool. More...
virtual StatusCode | sysStop ()=0
| Initialization of the Tool. More...
virtual StatusCode | sysFinalize ()=0
| Finalization of the Tool. More...
virtual StatusCode | sysReinitialize ()=0
| Initialization of the Tool. More...
virtual StatusCode | sysRestart ()=0
| Initialization of the Tool. More...
Public Member Functions inherited from INamedInterface
| DeclareInterfaceID (INamedInterface, 1, 0)
| InterfaceID. More...
virtual const std::string & | name () const =0
| Retrieve the name of the instance. More...
Public Member Functions inherited from IInterface
virtual void * | i_cast (const InterfaceID &) const =0
| main cast function More...
virtual std::vector< std::string > | getInterfaceNames () const =0
| Returns a vector of strings containing the names of all the implemented interfaces. More...
virtual unsigned long | addRef ()=0
| Increment the reference count of Interface instance. More...
virtual unsigned long | release ()=0
| Release Interface instance. More...
virtual unsigned long | refCount () const =0
| Current reference count. More...
virtual StatusCode | queryInterface (const InterfaceID &ti, void **pp)=0
| Set the void** to the pointer to the requested interface of the instance. More...
virtual | ~IInterface ()=default
| Virtual destructor. More...

## Private Attributes
Gaudi::Property< int > | m_shots {this, "Shots", 3500000, "number of shots for CPU normalization"}
Gaudi::Property< bool > | m_normalised {this, "Normalised", false, "normalise the time to a nominal PIII"}
Gaudi::Property< bool > | m_globalTiming {this, "GlobalTiming", false}
Gaudi::Property< std::string::size_type > | m_headerSize
int | m_indent = 0
| Amount of indentation. More...
std::vector< TimerForSequencer > | m_timerList
double | m_normFactor = 0.001
| Factor to convert to standard CPU (1 GHz PIII) More...
double | m_speedRatio = 0

## Additional Inherited Members
Public Types inherited from GaudiHistos< GaudiTool >
typedef GaudiAlg::HistoID | HistoID
| the actual type for histogram identifier More...
typedef GaudiAlg::Histo1DMapID | Histo1DMapID
| the actual type for (ID)->(1D histogram) mapping More...
typedef GaudiAlg::Histo1DMapTitle | Histo1DMapTitle
| the actual type for title->(1D histogram) mapping More...
typedef GaudiAlg::Histo2DMapID | Histo2DMapID
| the actual type for (ID)->(2D histogram) mapping More...
typedef GaudiAlg::Histo2DMapTitle | Histo2DMapTitle
| the actual type for title->(2D histogram) mapping More...
typedef GaudiAlg::Histo3DMapID | Histo3DMapID
| the actual type for (ID)->(3D histogram) mapping More...
typedef GaudiAlg::Histo3DMapTitle | Histo3DMapTitle
| the actual type for title->(3D histogram) mapping More...
typedef GaudiAlg::Profile1DMapID | Profile1DMapID
| the actual type for (ID)->(1D profile histogram) mapping More...
typedef GaudiAlg::Profile1DMapTitle | Profile1DMapTitle
| the actual type for title->(1D profile histogram) mapping More...
typedef GaudiAlg::Profile2DMapID | Profile2DMapID
| the actual type for (ID)->(2D profile histogram) mapping More...
typedef GaudiAlg::Profile2DMapTitle | Profile2DMapTitle
| the actual type for title->(2D profile histogram) mapping More...
typedef GaudiAlg::HistoBinEdges | HistoBinEdges
| Edges for variable binning. More...
Public Types inherited from IInterface
enum | Status : StatusCode::code_t { Status::FAILURE = 0, Status::SUCCESS = 1, Status::NO_INTERFACE, Status::VERSMISMATCH, Status::LAST_ERROR }
| Return status. More...
using | iid = Gaudi::InterfaceId< IInterface, 0, 0 >
| Interface ID. More...
using | ext_iids = Gaudi::interface_list< iid >
| Extra interfaces. More...
Static Public Member Functions inherited from GaudiTool
static bool | enableSummary (bool)
| enable/disable summary More...
static bool | summaryEnabled ()
| is summary enabled? More...
Static Public Member Functions inherited from IInterface
static const InterfaceID & | interfaceID ()
| Return an instance of InterfaceID identifying the interface. More...
Protected Types inherited from GaudiCommon< CounterHolder< AlgTool > >
using | base_class = FixTESPath< CounterHolder< AlgTool > >
typedef std::map< std::string, StatEntity > | StatisticsOwn
| the actual type of general counters More...
typedef std::map< std::string, std::reference_wrapper< Gaudi::Accumulators::PrintableCounter > > | Statistics
typedef std::map< std::string, unsigned int > | Counter
| the actual type error/warning counter More...
typedef std::vector< IAlgTool * > | AlgTools
| storage for active tools More...
typedef std::vector< SmartIF< IService > > | Services
| storage for active services More...
Protected Member Functions inherited from GaudiHistos< GaudiTool >
StatusCode | initialize () override
| standard initialization method More...
StatusCode | finalize () override
| standard finalization method More...
std::string | convertTitleToID (std::string title) const
| Create an ID string from a title string. More...
Protected Member Functions inherited from GaudiCommon< CounterHolder< AlgTool > >
StatusCode | releaseTool (const IAlgTool *tool) const
| manual forced (and 'safe') release of the tool More...
StatusCode | releaseSvc (const IInterface *svc) const
| manual forced (and 'safe') release of the service More...
Protected Attributes inherited from GaudiCommon< CounterHolder< AlgTool > >
SmartIF< ICounterSummarySvc > | m_counterSummarySvc
| a pointer to the CounterSummarySvc More...
Static Protected Attributes inherited from GaudiCommon< CounterHolder< AlgTool > >
static const bool | IgnoreRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...
static const bool | UseRootInTES
| Simple definition to be used with the new useRootInTES argument get<TYPE> and put methods. More...

## Detailed Description

Implements the time measurement inside a sequencer.

The width of the timing table column printing the algorithm name is 30 by default. That can be changed via

    TimingAuditor().addTool(SequencerTimerTool, name = "TIMER")
    TimingAuditor().TIMER.NameSize = 50

    @author Olivier Callot
    @date   2004-05-19

Definition at line 25 of file SequencerTimerTool.h.

## Constructor & Destructor Documentation

## ◆ SequencerTimerTool()

SequencerTimerTool::SequencerTimerTool | ( | const std::string & | type,
|  | const std::string & | name,
|  | const IInterface * | parent
| ) |  |

Standard constructor.

Definition at line 26 of file SequencerTimerTool.cpp.

27 : GaudiHistoTool( type, name, parent ) {
28 declareInterface<ISequencerTimerTool>( this );
29
30 // Histograms are disabled by default in this tool.
31 setProperty( "HistoProduce", false ).ignore();
32 }
GaudiHistoTool::GaudiHistoTool
GaudiHistoTool()=delete
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
setProperty
bool PyHelper() setProperty(IInterface *p, char *name, char *value)
Definition: Bootstrap.cpp:233
IAlgTool::parent
virtual const IInterface * parent() const =0
The parent of the concrete AlgTool.

## Member Function Documentation

## ◆ addTimer()

int SequencerTimerTool::addTimer | ( | const std::string & | name | ) |
| override virtual

add a timer entry with the specified name

Implements ISequencerTimerTool.

Definition at line 119 of file SequencerTimerTool.cpp.

119 {
120 std::string myName( 2 * m_indent, ' ' );
121 myName += name;
122 if ( myName.size() < m_headerSize ) { myName += std::string( m_headerSize - myName.size(), ' ' ); }
123 m_timerList.emplace_back( std::move( myName ), m_headerSize, m_normFactor );
124 return m_timerList.size() - 1;
125 }
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
std::string
STL class.
std::move
T move(T... args)
SequencerTimerTool::m_indent
int m_indent
Amount of indentation.
Definition: SequencerTimerTool.h:79
std::vector::size
T size(T... args)
SequencerTimerTool::m_timerList
std::vector< TimerForSequencer > m_timerList
Definition: SequencerTimerTool.h:80
SequencerTimerTool::m_headerSize
Gaudi::Property< std::string::size_type > m_headerSize
Definition: SequencerTimerTool.h:76
SequencerTimerTool::m_normFactor
double m_normFactor
Factor to convert to standard CPU (1 GHz PIII)
Definition: SequencerTimerTool.h:81
std::vector::emplace_back
T emplace_back(T... args)

## ◆ decreaseIndent()

void SequencerTimerTool::decreaseIndent | ( |  | ) |
| inline override virtual

Decrease the indentation of the name.

Implements ISequencerTimerTool.

Definition at line 49 of file SequencerTimerTool.h.

49 { m_indent = std::max( m_indent - 1, 0 ); }
std::max
T max(T... args)
SequencerTimerTool::m_indent
int m_indent
Amount of indentation.
Definition: SequencerTimerTool.h:79

## ◆ finalize()

StatusCode SequencerTimerTool::finalize | ( |  | ) |
| override virtual

finalize method, to print the time summary table

Implements IAlgTool.

Definition at line 61 of file SequencerTimerTool.cpp.

61 {
62
63 std::string line( m_headerSize + 68, '-' );
64 info() << line << endmsg << "This machine has a speed about " << format( "%6.2f", 1000. * m_speedRatio )
65 << " times the speed of a 2.8 GHz Xeon.";
66 if ( m_normalised ) info() << " *** All times are renormalized ***";
67 info() << endmsg << TimerForSequencer::header( m_headerSize ) << endmsg << line << endmsg;
68
69 std::string lastName;
70 for ( const auto& timr : m_timerList ) {
71 if ( lastName == timr.name() ) continue; // suppress duplicate
72 lastName = timr.name();
73 info() << timr << endmsg;
74 }
75 info() << line << endmsg;
76
77 return GaudiHistoTool::finalize();
78 }
TimerForSequencer::header
static std::string header(std::string::size_type size)
header matching the previous format
Definition: TimerForSequencer.cpp:60
format
GAUDI_API std::string format(const char *,...)
MsgStream format utility "a la sprintf(...)".
Definition: MsgStream.cpp:109
SequencerTimerTool::m_normalised
Gaudi::Property< bool > m_normalised
Definition: SequencerTimerTool.h:74
GaudiHistos< GaudiTool >::finalize
StatusCode finalize() override
standard finalization method
Definition: GaudiHistos.icpp:120
std::string
STL class.
SequencerTimerTool::m_timerList
std::vector< TimerForSequencer > m_timerList
Definition: SequencerTimerTool.h:80
SequencerTimerTool::m_headerSize
Gaudi::Property< std::string::size_type > m_headerSize
Definition: SequencerTimerTool.h:76
SequencerTimerTool::m_speedRatio
double m_speedRatio
Definition: SequencerTimerTool.h:82
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
plotSpeedupsPyRoot.line
line
Definition: plotSpeedupsPyRoot.py:170

## ◆ globalTiming()

bool SequencerTimerTool::globalTiming | ( |  | ) |
| inline override virtual

returns the flag telling that global timing is wanted

Implements ISequencerTimerTool.

Definition at line 67 of file SequencerTimerTool.h.

67 { return m_globalTiming; };
SequencerTimerTool::m_globalTiming
Gaudi::Property< bool > m_globalTiming
Definition: SequencerTimerTool.h:75

## ◆ increaseIndent()

void SequencerTimerTool::increaseIndent | ( |  | ) |
| inline override virtual

Increase the indentation of the name.

Implements ISequencerTimerTool.

Definition at line 46 of file SequencerTimerTool.h.

46 { m_indent += 1; }
SequencerTimerTool::m_indent
int m_indent
Amount of indentation.
Definition: SequencerTimerTool.h:79

## ◆ indexByName()

int SequencerTimerTool::indexByName | ( | const std::string & | name | ) |
| override virtual

returns the index of the counter with that name, or -1

Implements ISequencerTimerTool.

Definition at line 83 of file SequencerTimerTool.cpp.

83 {
84 auto beg = name.find_first_not_of( " \t" );
85 auto end = name.find_last_not_of( " \t" );
86 auto temp = name.substr( beg, end - beg + 1 );
87 auto i = std::find_if( std::begin( m_timerList ), std::end( m_timerList ), [&]( const TimerForSequencer& timer ) {
88 beg = timer.name().find_first_not_of( " \t" );
89 end = timer.name().find_last_not_of( " \t" );
90 return timer.name().compare( beg, end - beg + 1, temp ) == 0;
91 } );
92 return i != std::end( m_timerList ) ? std::distance( std::begin( m_timerList ), i ) : -1;
93 }
TimerForSequencer
Auxiliary class.
Definition: TimerForSequencer.h:20
std::distance
T distance(T... args)
std::string::find_first_not_of
T find_first_not_of(T... args)
TimerForSequencer::name
const std::string & name() const
returns the name
Definition: TimerForSequencer.h:41
std::end
T end(T... args)
INamedInterface::name
virtual const std::string & name() const =0
Retrieve the name of the instance.
IOTest.end
def end
Definition: IOTest.py:112
std::string::find_last_not_of
T find_last_not_of(T... args)
std::find_if
T find_if(T... args)
std::begin
T begin(T... args)
SequencerTimerTool::m_timerList
std::vector< TimerForSequencer > m_timerList
Definition: SequencerTimerTool.h:80
std::string::substr
T substr(T... args)
std::string::compare
T compare(T... args)

## ◆ initialize()

StatusCode SequencerTimerTool::initialize | ( |  | ) |
| override virtual

initialize method, to compute the normalization factor

Implements IAlgTool.

Definition at line 36 of file SequencerTimerTool.cpp.

36 {
37 const StatusCode sc = GaudiHistoTool::initialize();
38 if ( sc.isFailure() ) return sc;
39 double sum = 0;
40 TimerForSequencer norm( "normalize", m_headerSize, m_normFactor );
41 norm.start();
42 IRndmGenSvc* rsvc = svc<IRndmGenSvc>( "RndmGenSvc", true );
43 { // Use dummy loop suggested by Vanya Belyaev:
44 Rndm::Numbers gauss;
45 gauss.initialize( rsvc, Rndm::Gauss( 0., 1.0 ) ).ignore();
46 unsigned int shots = m_shots;
47 while ( 0 < --shots ) { sum += gauss() * sum; }
48 }
49 norm.stop();
50 double time = norm.lastCpu();
51 m_speedRatio = 1. / time;
52 info() << "This machine has a speed about " << format( "%6.2f", 1000. * m_speedRatio )
53 << " times the speed of a 2.8 GHz Xeon." << endmsg;
54 if ( m_normalised ) m_normFactor = m_speedRatio;
55 return sc;
56 }
plotSpeedupsPyRoot.time
def time
Definition: plotSpeedupsPyRoot.py:152
TimerForSequencer
Auxiliary class.
Definition: TimerForSequencer.h:20
format
GAUDI_API std::string format(const char *,...)
MsgStream format utility "a la sprintf(...)".
Definition: MsgStream.cpp:109
SequencerTimerTool::m_normalised
Gaudi::Property< bool > m_normalised
Definition: SequencerTimerTool.h:74
Rndm::Gauss
Parameters for the Gauss random number generation.
Definition: RndmGenerators.h:22
SequencerTimerTool::m_shots
Gaudi::Property< int > m_shots
Definition: SequencerTimerTool.h:73
Rndm::Numbers
Random number accessor This small class encapsulates the use of the random number generator.
Definition: RndmGenerators.h:349
IRndmGenSvc
Random Generator service interface definition Definition of a interface for a service to access rando...
Definition: IRndmGenSvc.h:35
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
Gaudi::Units::gauss
constexpr double gauss
Definition: SystemOfUnits.h:231
GaudiHistos< GaudiTool >::initialize
StatusCode initialize() override
standard initialization method
Definition: GaudiHistos.icpp:81
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
SequencerTimerTool::m_headerSize
Gaudi::Property< std::string::size_type > m_headerSize
Definition: SequencerTimerTool.h:76
SequencerTimerTool::m_speedRatio
double m_speedRatio
Definition: SequencerTimerTool.h:82
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
SequencerTimerTool::m_normFactor
double m_normFactor
Factor to convert to standard CPU (1 GHz PIII)
Definition: SequencerTimerTool.h:81

## ◆ lastTime()

double SequencerTimerTool::lastTime | ( | int | index | ) |
| inline override virtual

returns the last time

Implements ISequencerTimerTool.

Definition at line 58 of file SequencerTimerTool.h.

58 { return m_timerList[index].lastTime(); }
SequencerTimerTool::m_timerList
std::vector< TimerForSequencer > m_timerList
Definition: SequencerTimerTool.h:80

## ◆ name() [1/2]

virtual const std::string& ISequencerTimerTool::name

returns the name of the counter

## ◆ name() [2/2]

const std::string& SequencerTimerTool::name | ( | int | index | ) |
| inline override virtual

returns the name of the counter

Implements ISequencerTimerTool.

Definition at line 61 of file SequencerTimerTool.h.

61 { return m_timerList[index].name(); }
SequencerTimerTool::m_timerList
std::vector< TimerForSequencer > m_timerList
Definition: SequencerTimerTool.h:80

## ◆ saveHistograms()

void SequencerTimerTool::saveHistograms | ( |  | ) |
| override virtual

prepares and saves the timing histograms

Implements ISequencerTimerTool.

Definition at line 98 of file SequencerTimerTool.cpp.

98 {
99 if ( produceHistos() ) {
100 info() << "Saving Timing histograms" << endmsg;
101 const size_t bins = m_timerList.size();
102 AIDA::IHistogram1D* histoTime = book( "ElapsedTime", 0, bins, bins );
103 AIDA::IHistogram1D* histoCPU = book( "CPUTime", 0, bins, bins );
104 AIDA::IHistogram1D* histoCount = book( "Count", 0, bins, bins );
105 TH1D* tHtime = Gaudi::Utils::Aida2ROOT::aida2root( histoTime );
106 TH1D* tHCPU = Gaudi::Utils::Aida2ROOT::aida2root( histoCPU );
107 TH1D* tHCount = Gaudi::Utils::Aida2ROOT::aida2root( histoCount );
108 for ( const auto& tfsq : m_timerList ) {
109 tHtime->Fill( tfsq.name().c_str(), tfsq.elapsedTotal() );
110 tHCPU->Fill( tfsq.name().c_str(), tfsq.cpuTotal() );
111 tHCount->Fill( tfsq.name().c_str(), tfsq.count() );
112 }
113 }
114 }
Gaudi::Utils::Aida2ROOT::aida2root
static TH1D * aida2root(AIDA::IHistogram1D *aida)
get the underlying pointer for 1D-histogram
Definition: Aida2ROOT.cpp:70
std::vector::size
T size(T... args)
GaudiHistos< GaudiTool >::book
AIDA::IHistogram1D * book(const std::string &title, const double low=0, const double high=100, const unsigned long bins=100) const
book the 1D histogram
Definition: GaudiHistos.h:1849
SequencerTimerTool::m_timerList
std::vector< TimerForSequencer > m_timerList
Definition: SequencerTimerTool.h:80
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
GaudiHistos< GaudiTool >::produceHistos
bool produceHistos() const
get the flag for histogram production (property "HistoProduce")
Definition: GaudiHistos.h:2371

## ◆ start() [1/3]

virtual StatusCode IAlgTool::start

Start (from INITIALIZED to RUNNING).

## ◆ start() [2/3]

virtual void ISequencerTimerTool::start

start the counter, i.e.

register the current time

## ◆ start() [3/3]

void SequencerTimerTool::start | ( | int | index | ) |
| inline override virtual

start the counter, i.e.

register the current time

Implements ISequencerTimerTool.

Definition at line 52 of file SequencerTimerTool.h.

52 { m_timerList[index].start(); }
SequencerTimerTool::m_timerList
std::vector< TimerForSequencer > m_timerList
Definition: SequencerTimerTool.h:80

## ◆ stop() [1/3]

virtual double ISequencerTimerTool::stop

stop the counter, return the elapsed time

## ◆ stop() [2/3]

virtual StatusCode IAlgTool::stop

Stop (from RUNNING to INITIALIZED).

## ◆ stop() [3/3]

double SequencerTimerTool::stop | ( | int | index | ) |
| inline override virtual

stop the counter, return the elapsed time

Implements ISequencerTimerTool.

Definition at line 55 of file SequencerTimerTool.h.

55 { return m_timerList[index].stop(); }
SequencerTimerTool::m_timerList
std::vector< TimerForSequencer > m_timerList
Definition: SequencerTimerTool.h:80

## Member Data Documentation

## ◆ m_globalTiming

Gaudi::Property<bool> SequencerTimerTool::m_globalTiming {this, "GlobalTiming", false}
| private

Definition at line 75 of file SequencerTimerTool.h.

## ◆ m_headerSize

Gaudi::Property<std::string::size_type> SequencerTimerTool::m_headerSize
| private

Initial value:
{this, "NameSize", 30,
"number of characters to be used in algorithm name column"}

Definition at line 76 of file SequencerTimerTool.h.

## ◆ m_indent

int SequencerTimerTool::m_indent = 0
| private

Amount of indentation.

Definition at line 79 of file SequencerTimerTool.h.

## ◆ m_normalised

Gaudi::Property<bool> SequencerTimerTool::m_normalised {this, "Normalised", false, "normalise the time to a nominal PIII"}
| private

Definition at line 74 of file SequencerTimerTool.h.

## ◆ m_normFactor

double SequencerTimerTool::m_normFactor = 0.001
| private

Factor to convert to standard CPU (1 GHz PIII)

Definition at line 81 of file SequencerTimerTool.h.

## ◆ m_shots

Gaudi::Property<int> SequencerTimerTool::m_shots {this, "Shots", 3500000, "number of shots for CPU normalization"}
| private

Definition at line 73 of file SequencerTimerTool.h.

## ◆ m_speedRatio

double SequencerTimerTool::m_speedRatio = 0
| private

Definition at line 82 of file SequencerTimerTool.h.

## ◆ m_timerList

std::vector<TimerForSequencer> SequencerTimerTool::m_timerList
| private

Definition at line 80 of file SequencerTimerTool.h.

The documentation for this class was generated from the following files:

- GaudiAlg/src/components/SequencerTimerTool.h
- GaudiAlg/src/components/SequencerTimerTool.cpp